# git-for-beginners

Training material for the Git for Beginners ABiMS training session

## Course Outline

### Short Intro

 1. What is version management ?
 1. What is Git and why did we choose it ?
 1. What is GitLab and why did we choose it ?

### Trainee Setup Testing
  1. Does everyone have an account on GitLab ?

### Git Basics
  1. Creating a repository
  1. Adding / editing / removing files & folders
  1. Committing changes
  1. Pushing changes to the repository

### Branching Basics
  1. Default branches
  1. Creating new branches
  1. Switching between branches
  1. Merging branches

### Team collaboration
  1. Project roles in GitLab
  1. Branch Protection
  1. Submitting Merge Requests
  1. Handling Merge Requests
  1. Resolving Conflicts

### Using Git through the command line
  1. Configuring remote access to GitLab
  1. Git Survival Memo (`fetch`, `update`)

### Using Git through third party tools
  1. Using Git inside R-Studio
  1. Using Git inside PyCharm
  

### Further Reading
  1. [The Git Cheat Sheet](https://education.github.com/git-cheat-sheet-education.pdf)
  1. [The Git Book](https://git-scm.com/book/en/v2)
  1. [Git Workflows](https://www.atlassian.com/fr/git/tutorials/comparing-workflows/gitflow-workflow)


